
var FILE = require("modules/file");

exports.main = function(env)
{
	runner("script-all");
}

function runner(moduleId)
{
	try
	{
	    module.print("this before module load:\n");
	    for (var name in this)
	    {
   		 	module.print("  " + name + ": " + (typeof this[name]) + "\n");
	    }
		
	    var source = FILE.read(FILE.dirname(module.id) + "/" + moduleId + ".js");

	    // CommonJS module globals
	    var fRequire = function()
		    {
		    },
		    fExports = {
		    },
		    fModule = {
		    	print: module.print
		    };
	    
		module.print("Load module: " + moduleId + "\n");
	    factory(source, fRequire, fExports, fModule);
	    
	    module.print("Exports:\n");
	    for (var name in fExports)
	    {
   		 	module.print("  " + name + ": " + (typeof fExports[name]) + "\n");
	    }
	    
	    module.print("this after module load:\n");
	    for (var name in this)
	    {
   		 	module.print("  " + name + ": " + (typeof this[name]) + "\n");
	    }
	}
	catch(e)
	{
	    module.print("Module loader error: " + e + "\n");
	}
}

function factory(source, require, exports, module)
{
    try
    {
    	var globals = {};
    	
	    module.print("this before source run:\n");
	    for (var name in this)
	    {
	        globals[name] = this[name];
   		 	module.print("  " + name + ": " + (typeof globals[name]) + "\n");
   		 	delete this[name];
	    }
	    
	    var scope = {};
	  
	    with(scope)
	    {
		    eval(source);
	    }

	    module.print("scope after source run:\n");
	    for (var name in scope)
	    {
   		 	module.print("  " + name + ": " + (typeof scope[name]) + "\n");
	    }
	    
	    for (var name in pThis)
	    {
	    	this[name] = pThis[name];
	    }
	}
	catch (e)
	{
	    module.print("Module script error: " + e + "\n");
	}
	finally
	{
		module.print("New globals:\n");
	    for (var name in this)
	    {
	        if (typeof globals[name] === "undefined")
	        {
	     		module.print("  " + name + ": " + (typeof this[name]) + "\n");
	     		delete this[name];
	        }
	    }
	    for (var name in globals)
	    {
	    	this[name] = globals[name];
	    }
	}
	
	module.print("this after source run:\n");
	for (var name in this)
	{
		module.print("  " + name + ": " + (typeof this[name]) + "\n");
	}	
}
